unit formMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Samples.Spin, Vcl.StdCtrls,
  Vcl.ExtCtrls;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    edtReqFirstName: TLabeledEdit;
    edtReqLastName: TLabeledEdit;
    Salary: TLabel;
    spedReqSalary: TSpinEdit;
    spedResSalary: TSpinEdit;
    Label1: TLabel;
    edtResLastName: TLabeledEdit;
    edtResFirstName: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
uses
  unitIMyService
;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
var
  Service: IMyService;
  ReqEmployee: TMyEmployee;
  ResEmployee: TMyEmployee;
begin
  // capture interface to service
  Service := unitIMyService.GetIMyService();
  // build the request
  ReqEmployee := TMyEmployee.Create;
  try
    ReqEmployee.FirstName := edtReqFirstName.Text;
    ReqEmployee.LastName := edtReqLastName.Text;
    ReqEmployee.Salary := Trunc(spedReqSalary.Value);
    // Make the service request
    ResEmployee := Service.echoMyEmployee(ReqEmployee);
    try
      // Display the response
      edtResFirstName.Text := ResEmployee.FirstName;
      edtResLastName.Text := ResEmployee.LastName;
      spedResSalary.Value := Trunc(ResEmployee.Salary);
    finally
      ResEmployee.Free;
    end;
  finally
    ReqEmployee.Free;
  end;
end;

end.
